#!/bin/sh

# major architectures.
targets="arm-elf h8300-elf i386-elf mips-elf powerpc-elf sh-elf"

# other architectures.
targets="$targets arc-elf avr-elf cris-elf fr30-elf frv-elf hppa-linux"
targets="$targets m32r-elf m6811-elf m68k-elf mcore-elf mips64-elf mmix-elf"
targets="$targets mn10300-elf pdp11-aout powerpc64-linux s390-linux sh64-elf"
targets="$targets sparc-elf strongarm-elf v850-elf x86_64-linux xscale-elf"
targets="$targets xstormy16-elf xtensa-elf"

# need patches to build cross binutils/gcc.
targets="$targets alpha-elf ia64-elf vax-netbsdelf"

# need obsolete option to build cross gcc.
targets_obsolete="i960-elf"

# gcc cross build failed.
##targets="$targets alpha-linux alpha-vms bfin-elf hppa-elf"
##targets="$targets i370-elf i370-linux i960-elf iq2000-elf"
##targets="$targets m32c-elf microblaze-elf msp430-elf pdp11-dec-bsd"
##targets="$targets rs6000-aix x86_64-elf x86_64-w64-mingw32 z80-coff z8k-coff"
##targets_obsolete="$targets_obsolete vax-linux"

install_dir="/usr/local/cross"

# default definition
make=make

# for FreeBSD
#make=gmake
#SHELL=/usr/local/bin/bash

PATH=$PATH:$install_dir/bin

opt="--prefix=$install_dir --disable-nls"
opt="$opt --disable-threads --disable-shared --enable-languages=c"

for target in $targets; do
    mkdir -p $target
    cd $target
    ../../../gnu/gcc-3.4.6/configure --target=$target $opt
    $make
    cd ..
done

opt="$opt --enable-obsolete"

for target in $targets_obsolete; do
    mkdir -p $target
    cd $target
    ../../../gnu/gcc-3.4.6/configure --target=$target $opt
    $make
    cd ..
done
